#
# spec file for package 389-ds
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           389-ds
Summary:        389 Directory Server
License:        GPL-2.0
Group:          Productivity/Networking/LDAP/Servers
Version:        1.3.4.5
Release:        8.1
Url:            http://port389.org/

#DL-URL:          http://port389.org/wiki/Source
#Git-Clone:       git://git.fedorahosted.org/389/ds
Source:         http://www.port389.org/binaries/%name-base-%version.tar.bz2
Source9:        %name-rpmlintrc
# PATCH-FIX-SLES -- Make init scripts LSB conform
Patch0:         389-ds-base-1.3.2.11_init_fhs.patch
Patch1:         0001-Ticket-48375-SimplePagedResults-in-the-search-error-.patch
Patch2:         0002-Ticket-48406-Avoid-self-deadlock-by-PR_Lock-conn-c_m.patch
Patch3:         0003-Ticket-48924-Fixup-tombstone-task-needs-to-set-prope.patch
Patch4:         0004-Subject-PATCH-1-2-Bug-1347760-CVE-2016-4992-389-ds-b.patch
Patch5:         0005-Bug-1347760-CVE-2016-4992-389-ds-base-Information-di.patch
Patch6:         0006-Bug-1347760-CVE-2016-4992-389-ds-base-Information-di.patch
Patch7:         0007-Ticket-bz1358565-clear-and-unsalted-password-types-a.patch
Patch8:         0008-Ticket-bz1358565-clear-and-unsalted-password-types-a.patch
Patch9:         0009-Ticket-bz1358565-clear-and-unsalted-password-types-a.patch
Patch10:        0010-Ticket-bz1358565-clear-and-unsalted-password-types-a.patch
Patch11:        0011-Ticket-48986-47808-triggers-overflow-in-uiduniq.c.patch
Patch12:        0012-Ticket-49336-SECURITY-1.3.5.x-Locked-account-provide.patch
Patch13:        0013-Fix-for-cve-2017-2668-Remote-crash-via-crafted-LDAP-.patch
Patch14:        0014-Ticket-48412-worker-threads-do-not-detect-abnormally.patch

BuildRequires:  cyrus-sasl-devel
BuildRequires:  db-devel >= 4.5
BuildRequires:  gcc-c++
BuildRequires:  krb5-devel
# net-snmp-devel is needed to build the snmp ldap-agent
BuildRequires:  net-snmp-devel >= 5.1.2
BuildRequires:  openldap2-devel
# pam-devel is required by the pam passthru auth plug-in
BuildRequires:  pam-devel
%if 0%{?suse_version} < 1220
BuildRequires:  libicu-devel >= 3.4
BuildRequires:  mozilla-nspr-devel >= 4.6.4
BuildRequires:  mozilla-nss-devel >= 3.11.4
BuildRequires:  pcre-devel
BuildRequires:  svrcore-devel >= 4.0.3
%else
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(icu-i18n)
BuildRequires:  pkgconfig(icu-uc)
BuildRequires:  pkgconfig(libpcre)
BuildRequires:  pkgconfig(nspr)
BuildRequires:  pkgconfig(nss)
BuildRequires:  pkgconfig(svrcore)
BuildRequires:  pkgconfig(systemd)
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Requires:       cyrus-sasl-digestmd5
Requires:       cyrus-sasl-gssapi
Requires:       mozilla-nss-tools
Requires:       openldap2-client
Requires:       perl(Mozilla::LDAP::API)
Requires:       perl(Mozilla::LDAP::Conn)
Requires:       perl(Mozilla::LDAP::Entry)
Requires:       perl(Mozilla::LDAP::LDIF)
Requires:       perl(Mozilla::LDAP::Utils)
Requires:       perl(NetAddr::IP)
Requires:       perl(Socket6)

%if 0%{?suse_version} < 1220
%define __without_systemd 0
%endif

%bcond_without systemd

%if 0%{?suse_version} >= 1230
Requires:       %_sbindir/service
%else
Requires:       /sbin/service
%endif
Requires(post):   fillup
%if %{with systemd}
%{?systemd_requires}
%else
Requires(post):   insserv
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig
%endif

Obsoletes:      389-ds-base < %version-%release
Provides:       389-ds-base = %version-%release

%description
389 Directory Server is a full-featured LDAPv3 compliant server. In
addition to the standard LDAPv3 operations, it supports multi-master
replication, fully online configuration and administration, chaining,
virtual attributes, access control directives in the data, Virtual
List View, server-side sorting, SASL, TLS/SSL, and many other
features. (The server started out as Netscape Directory Server.)

%package devel
Summary:        Development files for the 389 Directory Server
Group:          Development/Libraries/C and C++
Requires:       %name = %version-%release

%description devel
389 Directory Server is a full-featured LDAPv3 compliant server. In
addition to the standard LDAPv3 operations, it supports multi-master
replication, fully online configuration and administration, chaining,
virtual attributes, access control directives in the data, Virtual
List View, server-side sorting, SASL, TLS/SSL, and many other
features.

This package contains the development files for 389DS.

%prep
%setup -qn %name-base-%version
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1

%build
# openldap has no pkgconfig file; because of that, 389ds will prefer
# mozldap. Force use of openldap.
%configure \
	--bindir=%_libexecdir/%name/bin \
	--sbindir=%_libexecdir/%name/sbin \
	--enable-autobind \
	--with-openldap \
%if %{with systemd}
	--with-systemdsystemunitdir \
	--with-systemdsystemconfdir \
	--with-systemdgroupname=dirsrv.target \
%else
	--with-initddir="%_initddir" \
%endif
	.

make %{?_smp_mflags}

%install
b="%buildroot"
make install DESTDIR="$b"

install -d "$b/%_sbindir"
ln -s "%_libexecdir/%name/sbin/setup-ds.pl" "$b/%_sbindir/setup-ds.pl"

%if %{with systemd}
install -d "$b/%_unitdir/dirsrv.target.wants"
%if 0%{?suse_version} >= 1230
ln -s service "$b/%_sbindir/rcdirsrv"
ln -s service "$b/%_sbindir/rcdirsrv-snmp"
%else
ln -s /sbin/service "$b/%_sbindir/rcdirsrv"
ln -s /sbin/service "$b/%_sbindir/rcdirsrv-snmp"
%endif
%else
ln -s "%_initddir/dirsrv" "$b/%_sbindir/rcdirsrv"
ln -s "%_initddir/dirsrv-snmp" "$b/%_sbindir/rcdirsrv-snmp"
%endif

install -d "$b/%_localstatedir/adm/fillup-templates"
for i in "$b/%_sysconfdir/sysconfig"/*; do
	mv "$i" "$b/%_localstatedir/adm/fillup-templates/sysconfig.${i##*/}"
done
find "$b/%_libdir" -type f -name "*.la" -delete

# make sure perl scripts have a proper shebang 
sed -i -e 's|#{{PERL-EXEC}}|#!%_bindir/perl|' "$b/%_datadir/dirsrv/script-templates"/template-*.pl

%if %{with systemd}
%pre
%service_add_pre dirsrv@*.service dirsrv-snmp.service dirsrv.target
%endif

%post
/sbin/ldconfig
%if %{with systemd}
%fillup_only -n dirsrv
%fillup_only -n dirsrv.systemd
%service_add_post dirsrv@*.service dirsrv-snmp.service dirsrv.target
%else
%fillup_and_insserv dirsrv
%fillup_and_insserv dirsrv-snmp
%endif

%preun
%if %{with systemd}
%service_del_preun dirsrv@*.service dirsrv-snmp.service dirsrv.target
%else
%stop_on_removal dirsrv
%stop_on_removal dirsrv-snmp
%endif

%postun
/sbin/ldconfig
%if %{with systemd}
%service_del_postun dirsrv@*.service dirsrv-snmp.service dirsrv.target
%else
%restart_on_update dirsrv
%restart_on_update dirsrv-snmp
%insserv_cleanup
%endif

%files
%defattr(-,root,root)
%doc LICENSE README
%dir %_sysconfdir/dirsrv
%dir %_sysconfdir/dirsrv/schema
%config(noreplace) %_sysconfdir/dirsrv/schema/*.ldif
%dir %_sysconfdir/dirsrv/config
%config(noreplace) %_sysconfdir/dirsrv/config/slapd-collations.conf
%config(noreplace) %_sysconfdir/dirsrv/config/certmap.conf
%config(noreplace) %_sysconfdir/dirsrv/config/ldap-agent.conf
%config(noreplace) %_sysconfdir/dirsrv/config/template-initconfig
%_datadir/dirsrv
%if %{with systemd}
%_unitdir/dirsrv*
%else
%_initddir/dirsrv*
%endif
%_libexecdir/%name/
%_sbindir/*
%dir %_libdir/dirsrv
%_libdir/dirsrv/*.so.*
%dir %_libdir/dirsrv/perl
%_libdir/dirsrv/perl/*.pm
%dir %_libdir/dirsrv/plugins
%_libdir/dirsrv/plugins/*.so
%dir %_libdir/dirsrv/python
%_libdir/dirsrv/python/*.py
%_localstatedir/adm/fillup-templates/sysconfig.*
%_mandir/man1/*
%_mandir/man8/*

%files devel
%defattr(-,root,root)
%doc LICENSE README
%_includedir/dirsrv
%_libdir/dirsrv/*.so
%_libdir/pkgconfig/dirsrv.pc

%changelog
* Tue Dec  5 2017 hguo@suse.com
- Cherry pick upstream CVE fixes:
  * 0001-Ticket-48375-SimplePagedResults-in-the-search-error-.patch
  * 0002-Ticket-48406-Avoid-self-deadlock-by-PR_Lock-conn-c_m.patch
  * 0003-Ticket-48924-Fixup-tombstone-task-needs-to-set-prope.patch
  * 0004-Subject-PATCH-1-2-Bug-1347760-CVE-2016-4992-389-ds-b.patch
  * 0005-Bug-1347760-CVE-2016-4992-389-ds-base-Information-di.patch
  * 0006-Bug-1347760-CVE-2016-4992-389-ds-base-Information-di.patch
  * 0007-Ticket-bz1358565-clear-and-unsalted-password-types-a.patch
  * 0008-Ticket-bz1358565-clear-and-unsalted-password-types-a.patch
  * 0009-Ticket-bz1358565-clear-and-unsalted-password-types-a.patch
  * 0010-Ticket-bz1358565-clear-and-unsalted-password-types-a.patch
  * 0011-Ticket-48986-47808-triggers-overflow-in-uiduniq.c.patch
  * 0012-Ticket-49336-SECURITY-1.3.5.x-Locked-account-provide.patch
  * 0013-Fix-for-cve-2017-2668-Remote-crash-via-crafted-LDAP-.patch
  * 0014-Ticket-48412-worker-threads-do-not-detect-abnormally.patch
  For bsc#1051997, bsc#1007004, bsc#1020670, bsc#1069074, bsc#1069067,
  bsc#997256 that correspond to CVE-2017-7551, CVE-2016-5405,
  CVE-2017-2668, CVE-2017-2668, CVE-2016-4992.
* Fri Nov 20 2015 aj@ajaissle.de
- Update to new upstream release 1.3.4.5
  * Various bugs are fixed
* Mon Sep 14 2015 hguo@suse.com
- Upgrade from 1.3.3.13 to 1.3.4.4 with accumulated bugfixes.
* Wed Sep  9 2015 aj@ajaissle.de
- Update to new upstream release 1.3.3.13
- Removed 389-ds-1.3.3.11-CVE-2015-3230.patch (included upstream)
* Wed Jun 17 2015 aj@ajaissle.de
- Update to new upstream release 1.3.3.11
- Added 389-ds-1.3.3.11-CVE-2015-3230.patch:
  nsSSL3Ciphers preference not enforced on server side
  [boo#934934] [CVE-2015-3230]
* Wed Apr 29 2015 aj@ajaissle.de
- Update to new upstream release 1.3.3.10
  * One important security bug was fixed:
    Bug 1216203 - CVE-2015-1854 389ds-base: access control bypass with modrdn
* Wed Apr 15 2015 jengelh@inai.de
- Simplify filelist
* Mon Apr 13 2015 aj@ajaissle.de
- Move bin/ and sbin/ to /usr/lib/389-ds/bin resp. sbin/
- Removed conflict with atheme
* Sat Mar 28 2015 aj@ajaissle.de
- Update to new upstream release 1.3.3.9
  * Several bugs are fixed including 2 security bugs
    Bug 1199675 - CVE-2014-8112 CVE-2014-8105 389-ds-base: various flaws [fedora-all]
    Ticket 47431 - Duplicate values for the attribute nsslapd-pluginarg are not handled correctly
    Ticket 47451 - dynamic plugins - fix crash caused by invalid plugin config
    Ticket 47728 - compilation failed with ' incomplete struct/union/enum' if not set USE_POSIX_RWLOCKS
    Ticket 47742 - 64bit problem on big endian: auth method not supported
    Ticket 47801 - RHDS keeps on logging write_changelog_and_ruv: failed to update RUV for unknown
    Ticket 47828 - DNA scope: allow to exlude some subtrees
    Ticket 47836 - Do not return '0' as empty fallback value of nsds5replicalastupdatestart and nsds5replicalastupdatestart
    Ticket 47901 - After total init, nsds5replicaLastInitStatus can report an erroneous error status (like 'Referral')
    Ticket 47936 - Create a global lock to serialize write operations over several backends
    Ticket 47957 - Make ReplicaWaitForAsyncResults configurable
    Ticket 48001 - ns-activate.pl fails to activate account if it was disabled on AD
    Ticket 48003 - add template scripts
    Ticket 48003 - build "suite" framework
    Ticket 48005 - ns-slapd crash in shutdown phase
    Ticket 48021 - nsDS5ReplicaBindDNGroup checkinterval not working properly
    Ticket 48027 - revise the rootdn plugin configuration validation
    Ticket 48030 - spec file should run "systemctl stop" against each running instance instead of dirsrv.target
    Ticket 48048 - Fix coverity issues - 2015/2/24
    Ticket 48048 - Fix coverity issues - 2015/3/1
    Ticket 48109 - substring index with nssubstrbegin: 1 is not being used with filters like (attr=x*)
* Wed Dec 24 2014 aj@ajaissle.de
- Conflicts with atheme -- /usr/sbin/dbverify
* Tue Dec  9 2014 aj@ajaissle.de
- Update to new upstream release 1.3.3.5
  * Several bugs are fixed.
* Tue Sep  9 2014 aj@ajaissle.de
- Update to new upstream release 1.3.3.0
  * First cut of 389-ds-base-1.3.3.x
* Fri Aug 29 2014 aj@ajaissle.de
- Update to new upstream release 1.3.2.23
  * Various bugs were fixed
- Highlights since 1.3.2.16:
  * Important bugs including memory leaks and crash bugs were fixed
  (1.3.2.17)
  * Various bugs were fixed (1.3.2.18)
  * Various bugs were fixed (1.3.2.19)
  * A security bug was fixed (1.3.2.22)
* Thu Mar 27 2014 aj@ajaissle.de
- Update to new upstream release 1.3.2.16
  * Directory server is insecurely misinterpreting authzid on a SASL/GSSAPI bind
  * Create a normalized dn cache
  * Replication retry time attributes cannot be added
  * Empty control list causes LDAP protocol error is thrown (dup 47361)
  * Failed to compile the DS 389 1.3.2.3 version against Berkeley DB 4.2 version
  * Windows Sync group issues
  * Size returned by slapi_entry_size is not accurate
  * Single valued attribute replicated ADD does not work
  * Environment variables are not passed when DS is started via service
  * Propagate plugin precedence to all registered function types
  * Unresolved external symbol references break loading of the ACL plugin
  * Package issue in 389-ds-base
- Fix unresolveable 'Requires:'
  * perl(Mozilla:LDAP) -> perl(Mozilla::LDAP::API), perl(Mozilla::LDAP::Conn),
  perl(Mozilla::LDAP::Entry), perl(Mozilla::LDAP::LDIF), perl(Mozilla::LDAP::Utils)
  * cyrus-sasl-md5 -> cyrus-sasl-digestmd5
- Macros for dirsrv-snmp in pre/post/preun/postun
* Mon Feb 17 2014 aj@ajaissle.de
- Update to new upstream release 1.3.2.11
  * Enhancement: ACL supports new keyword SELFDN as in "<userattr> =
  <attribute>#SELFDN" to allow users to create entries assigned to
  themselves. Also handling subtype in ACL is improved.
  * A dozen of bugs are fixed including a crash bug and a deadlock.
- Spec cleanup
  * enable init scripts for openSUSE < 1220 (e.g. SLES)
  * dirsrv.target.wants goes into unitdir
  * Added a 389-ds-rpmlintrc
- Added 389-ds-base-1.3.2.11_init_fhs.patch
  * Make init scripts LSB conform
* Fri Dec 27 2013 jengelh@inai.de
- Update to new upstream release 1.3.2.10
  * Suffixes used in the memberof and referential integrity plug-ins
  are now configurable.
  * The hard-coded limit of 64 masters was removed.
  * Enhancements: plug-in library path validation, replication
  logging, changelog trimming interval, and referential integrity.
* Fri Aug  2 2013 jengelh@inai.de
- Update to new upstream release 1.3.1.5
  * Plug-in transaction support
  * Normalized DN cache
  * Configurable allowed SASL mechanisms
  * SASL mapping improvements
  * Configurable SASL buffer
  * Replication retry settings
  * Instance script improvements
  * Access log analyzer improvements
  * Performance improvements
* Mon Mar 11 2013 jengelh@inai.de
- Update to new upstream release 1.3.0.3
  * No NEWS file available; SCM changelog entries at
  http://port389.org/wiki/Releases/1.3.0.2#New_features_.2F_Fixed_bugs_in_1.3.0
* Wed Sep 26 2012 jengelh@inai.de
- Update to new upstream release 1.2.11.15
  * This is a bugfix release to CLEANALLRUV, userpassword,
  schema reloading and others.
* Mon Sep 17 2012 jengelh@inai.de
- Initial package (version 1.2.11.12) for build.opensuse.org
